'use strict';

var autoprefixer = require('gulp-autoprefixer');
var browserSync  = require('browser-sync').create();
var gulp         = require('gulp');
var sass         = require('gulp-sass');

var baseDir      = './src/';
var tasks        = ['scss'];

gulp.task('scss', function() {
    return gulp.src([baseDir + 'scss/selecton-light.scss', baseDir + 'scss/selecton-dark.scss'])
        .pipe(sass({
            outputStyle : 'expanded'
        })
        .on('error', sass.logError))
        .pipe(autoprefixer({
            browsers: ['last 50 versions', 'ie >= 9'],
            cascade: false
        }))
        .pipe(gulp.dest('build/css'))
        .pipe(browserSync.stream());
});

gulp.task('scss-watch', ['scss'], function (done) {
    done();
});

gulp.task('default', tasks, function () {

    browserSync.init({
        open: false,
        reloadOnRestart: true,
        server: {
            baseDir: './build',
        }
    });

    gulp.watch(baseDir + 'scss/**/*.scss', ['scss-watch']);
    gulp.watch(['build/index.html', 'build/selecton.js']).on('change', browserSync.reload);
});
